set C; # sets of classed (ways of taking two days off)  e.g. {(1,2),(1,3),...(6,7)}
set Ccon; # {(1,2),(2,3),...,(1,7)}
set Csep; # C\Ccon
set D; # sets of days = {1,2,...,7} 
set S; #sets of shifts = {1,2,3}
set Cd {D};#sets of classes whose agents work on days d  = {(i,j) in C | i!= d, j!=d}



param Wp; #per shift wage for a part time agent
param Wf_BD; #per week wage for a full-time agent in Bording
param Wf_sep; #per week compensation for a full-time agent if her/his off days are separated
param K; # number of full-time agents in BD
param Nds{D,S}; # number of agents needed for boarding division in shift s on day d

var x_c{C}; # number of full-time agents assigned to class C
var y_ds{D,S} ; # number of full-time agents in bording assigned in shift s on day d
var w_ds{D,S}; #number of part time agents hired in shift s on day d



minimize cost: Wf_BD  * sum{c in Ccon}(x_c[c]) + (Wf_BD + Wf_sep) * sum{c in Csep}(x_c[c])
+ Wp*sum{d in D}(sum{s in S}(w_ds[d,s]));

subject to notifire: sum{c in C}(x_c[c]) >=  K; # cannot fire current full-time agents

subject to assign{d in D}: sum{s in S}(y_ds[d,s]) = sum{c in Cd[d]}(x_c[c]); # assigning agents working on d to shifts s

subject to demand{d in D, s in S}: y_ds[d,s] + w_ds[d,s]>= Nds[d,s];

#nonnegative
subject to nonnegX{c in C}: x_c[c] >= 0; 
subject to nonnegY{d in D, s in S}: y_ds[d,s] >= 0; 
subject to nonnegW{d in D, s in S}: w_ds[d,s] >=0 ;