set C; # sets of classed (ways of taking two days off)  e.g. {(1,2),(1,3),...(6,7)}
set Ccon; # {(1,2),(2,3),...,(1,7)}
set Csep; # C\Ccon
set D; # sets of days = {1,2,...,7} 
set S; #sets of shifts = {1,2,3}
set G; # set of groups = {BD, IEDO, ANTS, SVVRL, KMM}
set T; #set of tasks |G|=|T|

set Tg{G}; #set of tasks |G|=|T|
set Gt{T}; #set of groups whose agents can do task t
set IEDO; # = IEDO
set NIEDO; # = ANTS	SVVRL	KMM
set Cd {D}; #sets of classes whose agents work on days d = {(i,j) in C | i!= d, j!=d}
set Gp;  #set of part-time agents can do task t


param Wp{Gp}; #per shift wage for a part time agent in group g
param Wf_g{G}; #per week wage for a full-time agent in group g
param Wf_sep; #per week compensation for a full-time agent if her/his off days are separated
param Kg{G}; # number of full-time agents in group g
param Ndst{T,D,S}; # number of agents needed for task t in shift s on day d


var x_cg{C,G}; # number of full-time agents in g assigned to class C
var y_dstg{D,S,T,G}; # number of full-time agents in group g assigned to do task t in shift son day d
var w_dst{D,S,T}; #number of part time agents hired in shift s on day d for task t


minimize cost: sum{g in G}(Wf_g[g] * sum{c in Ccon}(x_cg[c,g])) + sum{g in G}((Wf_g[g] + Wf_sep) * (sum{c in Csep}(x_cg[c,g]))) + sum{t in Gp}(Wp[t] * (sum{d in D}(sum{s in S}(w_dst[d,s,t]))));

subject to notifire{g in G}: sum{c in C}(x_cg[c,g]) >=  Kg[g]; # cannot fire current full-time agents
subject to assign{d in D, g in G}: sum{t in Tg[g]}(sum{s in S}(y_dstg[d,s,t,g])) = sum{c in Cd[d]}(x_cg[c,g]); # assigning agents working in dto shift s
subject to demand1{d in D, s in S, t in NIEDO}: sum{g in Gt[t]}(y_dstg[d,s,t,g]) >= Ndst[t,d,s];
subject to demand2{d in D, s in S, t in IEDO}: sum{g in Gt[t]}(y_dstg[d,s,t,g]) + w_dst[d,s,t] >= Ndst[t,d,s];

#nonnegative
subject to nonnegX{c in C, g in G}: x_cg[c,g] >= 0; 
subject to nonnegY{d in D, s in S, t in T, g in G}: y_dstg[d,s,t,g] >= 0; 
subject to nonnegW{d in D, s in S, t in T}: w_dst[d,s,t] >= 0;