set C; # sets of classed (ways of taking two days off)   e.g. {(1,2),(1,3),K(6,7)}

set Ccon; # {(1,2),(2,3),...,(1,7)}

set Csep; # C\Ccon

set D; # sets of days = {1,2,...,7}

set S; #sets of shifts = {1,2,3}


set Cds {D,S};#sets of classed whose agents work in days d in D in shift s = {(i,j) in C | i!= d, j!=d}



param Wp; #per shift wage for a part time agent in group g in G

param Wf_BD; #per week wage for a full-time agent in BD

param Wf_sep; #per week compensation for a full-time agent if her/his off days are separated

param K; # number of full-time agents in BD


param Nds{D,S}; # number of agents needed for task BD in shift s in S in day d in D



var x_c{C} integer; # number of full-time agents in group g in G assigned to class in C

var w_ds{D,S} integer; #number of part time agents hired in shift s in S in day d in D for task t t in BD




minimize cost:
Wf_BD  * sum{c in Ccon}(x_c[c]) + (Wf_BD + Wf_sep) * sum{c in Csep}(x_c[c])
+ Wp*sum{d in D}(sum{s in S}(w_ds[d,s]));
subject to notifire: sum{c in C}(x_c[c]) >=  K; # cannot fire full-time agents


subject to demand{d in D, s in S}: sum{c in Cds[d,s]}(x_c[c]) + w_ds[d,s] >= Nds[d,s];


subject to nonnegX{c in C}: x_c[c] >= 0; 
subject to nonnegW{d in D, s in S}: w_ds[d,s] >=0 ;